SixPing
2016-04-03 08:35
采纳率: 42.9%
浏览 1.6k
已采纳

按书上写了一段java捕获异常的代码,不知道问题出在哪里

源代码如下:
package com.Sixping.Ncre;

public class Rethrow {
public static void rt() throws Exception {//定义方法,抛出Exception类的异常
System.out.println("old exception in rt()");
throw new Exception("thrown from rt()");
}
public static void wq() throws Throwable {//定义方法,调用rt(),捕获rt()抛出的异常
try {
rt();
} catch (Exception e) {
System.out.println("Inside wq(),e.printStackTrace():");
e.printStackTrace(); //输出堆栈使用情况
throw e; //重新抛出异常
}
}
public static void main(String[] args) throws Throwable {
try {
wq(); //产生被重新抛出的对象
} catch (Exception e) {
System.out.println("Caught in main,e.printStackTrace():");
e.printStackTrace(); //再次输出堆栈信息
}
}
}

运行报错如下:
old exception in rt()

java.lang.Exception: thrown from rt()
at com.Sixping.Ncre.Rethrow.rt(Rethrow.java:6)
at com.Sixping.Ncre.Rethrow.wq(Rethrow.java:10)
at com.Sixping.Ncre.Rethrow.main(Rethrow.java:19)
java.lang.Exception: thrown from rt()
at com.Sixping.Ncre.Rethrow.rt(Rethrow.java:6)
at com.Sixping.Ncre.Rethrow.wq(Rethrow.java:10)
at com.Sixping.Ncre.Rethrow.main(Rethrow.java:19)
Inside wq(),e.printStackTrace():
Caught in main,e.printStackTrace():

求大神解答

  • 写回答
  • 好问题 提建议
  • 关注问题
  • 收藏
  • 邀请回答

2条回答 默认 最新

  • 毕小宝 2016-04-03 10:16
    已采纳

    没有错误啊,你不就是测试异常抛出嘛,流程是这样的;
    首先,rt()方法抛出了异常,然后你在wq()方法中捕获并上抛出,直至main方法中捕获的是Exception,但是wq抛出的Throwable异常没有处理,所以被main方法继续抛出给虚拟机了。
    代码运行是正确的,这不是运行时报错,而是你就是测试的throw e,抛出异常后你在捕获分支中使用的是e.printStack打印堆栈信息了。这个流程是对的,你可以注释调用e.printStackTrace(); 就能发现不会打印堆栈日志了。

    已采纳该答案
    评论
    解决 无用
    打赏 举报
  • ljheee 2016-04-04 13:38

    代码没有什么语法、逻辑错误。
    rt()方法抛出了异常,在wq()方法中捕获并继续抛出,抛给main方法,main方法继续抛给虚拟机,虚拟机能做的就是终止程序。
    这些行堆栈日志 信息由e.printStackTrace(); 打印输出

    评论
    解决 无用
    打赏 举报

相关推荐 更多相似问题